From 0cb4514cfb42e5b4ecf76701a6387c364070b1ed Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 10 2020 04:53:04 +0000
Subject: [PATCH 1327/2232] Merge pull request #440 from dtolnay/result


Improve placement of diagnostic on Result without Display impl
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 57b64b5..a01c1c6 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -670,12 +670,14 @@ fn expand_rust_function_shim_super(
     let args = sig.args.iter().map(|arg| quote!(#arg));
     let all_args = receiver.chain(args);
 
-    let ret = if sig.throws {
+    let ret = if let Some((result, _langle, rangle)) = sig.throws_tokens {
         let ok = match &sig.ret {
             Some(ret) => quote!(#ret),
             None => quote!(()),
         };
-        quote!(-> ::std::result::Result<#ok, impl ::std::fmt::Display>)
+        let impl_trait = quote_spanned!(result.span=> impl);
+        let display = quote_spanned!(rangle.span=> ::std::fmt::Display);
+        quote!(-> ::std::result::Result<#ok, #impl_trait #display>)
     } else {
         expand_return_type(&sig.ret)
     };
diff --git a/tests/ui/result_no_display.stderr b/tests/ui/result_no_display.stderr
index e92cd36..d0502f9 100644
--- a/tests/ui/result_no_display.stderr
+++ b/tests/ui/result_no_display.stderr
@@ -1,8 +1,8 @@
 error[E0277]: `NonError` doesn't implement `std::fmt::Display`
- --> $DIR/result_no_display.rs:1:1
+ --> $DIR/result_no_display.rs:4:19
   |
-1 | #[cxx::bridge]
-  | ^^^^^^^^^^^^^^ `NonError` cannot be formatted with the default formatter
+4 |         fn f() -> Result<()>;
+  |                   ^^^^^^^^^^ `NonError` cannot be formatted with the default formatter
   |
   = help: the trait `std::fmt::Display` is not implemented for `NonError`
   = note: in format strings you may be able to use `{:?}` (or {:#?} for pretty-print) instead

